
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "image_hunter.h"
#include "mensajes.h"

/* ------------------- */
/* PROGRAMA PRINCIPAL  */
/* ------------------- */

int main (int argc, char **argv)
{
   Cola *cola;
   int sock;
   char texto_html[TAM_FICHERO_HTML];
   char sentencia[TAM_SENTENCIA_HTTP];
   char directorio[TAM_NOMBRE_DIRECTORIO];
   int home_page;
   
   char nombre_servidor[TAM_NOMBRE_IMAGEN];
   char html_enlace[TAM_NOMBRE_IMAGEN];
   
   if (argc != 2) {
      fprintf(stderr," Sintaxis: image_hunter host \n");
      fprintf(stderr,"           host --> servidor del que extraer las imagenes de su pagina inicial. \n");
      fprintf(stderr," Ejemplo: image_hunter www.e-mtb.com \n");
      return -1;
   }
      
   // Pagina tipo http://www.servidor.com*
   if (comprobar_imagen_enlazada(argv[1], nombre_servidor, html_enlace)) {
      // Conexion TCP al puerto 80 del servidor
      sock = conexion_servidor(nombre_servidor,MODO_TEXTUAL);
      if (sock == -1) {
         return -1;
      }
      
      // Si la direccion es http://www.servidor.com <- sin barra ni pagina
      if (strcmp(html_enlace, "") == 0) {
         strcpy(html_enlace, "/");
      }
      construir_peticion_http(PETICION_HOME_PAGE,sentencia,nombre_servidor,html_enlace);
      
   } else { 
      // Indicado servidor como parametro www.servidor.com
      strcpy(nombre_servidor,argv[1]);
      
      // Conexion TCP al puerto 80 del servidor
      sock = conexion_servidor(nombre_servidor,MODO_TEXTUAL);
      if (sock == -1) {
         return -1;
      }
      
      construir_peticion_http(PETICION_HOME_PAGE,sentencia,nombre_servidor,"/");
   }
   
   home_page = obtener_home_page(sock,sentencia,texto_html,nombre_servidor,MODO_TEXTUAL);
   close(sock);
      
   if (!home_page) {
      return -1;
   }
   
   // Extraccion de las imagenes referenciadas en la pagina de inicio del servidor
   // Los paths de las imagenes extaidas estaran almacenados en la cola recibida

   cola = buscador_imagenes(texto_html);
   
   if (!cola_vacia(cola)) {
      
      // Comprobacion de la existencia del directorio de almacenamiento y del
      // subdirectorio que almacenara las imagenes del servidor actual.
      
      strcpy(directorio,"images");
      comprobar_directorio(directorio,"",DIRECTORIO_RAIZ);
      comprobar_directorio(directorio,nombre_servidor,SUBDIRECTORIO);
      
      // Obtencion de todas las imagenes de la pagina de inicio mediante solicitud HTTP.
      // Ubicacion de las imagenes recibidas en el directorio especificado.
      
      solicitar_imagenes(nombre_servidor,cola,directorio,MODO_TEXTUAL);
   }
   else {
      printf("\nNo se han encontrado imagenes en la pagina de inicio de %s.\n\n",nombre_servidor);
   }
   return 0;
}

