
/******************************************************************************/
/*                                                                            */
/*  XARXES DE COMPUTADORS I                                                   */
/*                                                                            */
/*  Practica 3: Image Hunter                                                  */
/*  Extraccion de todas las imagenes de la pagina de inicio del servidor      */
/*  especificado, y almacenamiento en disco de cada una de ellas.             */
/*                                                                            */
/*  Fichero cola.h: especificacion de las estructuras y funciones de la cola. */
/*  Realizado por: Francisco Jose Aguilar Celdran y Sergio Blanco Cuaresma    */
/*                                                                            */
/******************************************************************************/

#ifndef COLA_H
#define COLA_H
  
   struct Tipo_Nodo
   {
      unsigned char *nodo;
      struct Tipo_Nodo *anterior;
   };
   typedef struct Tipo_Nodo Nodo;

   struct Tipo_Cola
   {
      Nodo *primero;
      Nodo *ultimo;
      Nodo *pdi;
      unsigned int total;
   };       
   typedef struct Tipo_Cola Cola;

   Cola *crear_cola(void);
   unsigned int cola_vacia(Cola *c);
   void encolar(Cola *c,char *valores);
   void desencolar(Cola *c);
   unsigned char *primero(Cola *c);
   void reiniciar_PDI(Cola *c);
   unsigned char *obtener_elemento_PDI(Cola *c);
   int avanzar_PDI(Cola *c);
   void vaciar_cola(Cola *c);
   
#endif

