
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "image_hunter.h"
#include "mensajes.h"

Cola *lista_imagenes = NULL;
char *nombre_directorio;
int numero_imagen;

void cazador_imagenes (char* string_servidor, GtkWidget *objeto);
void *obtener_ruta_imagen (char *path_imagen, char *directorio, char *imagen);

void on_button_Cazador_clicked (GtkButton *button, gpointer user_data)
{
   GtkWidget *window_Resultados;
   GtkWidget *caja_texto;
   GtkWidget *check_ver_imagenes;
   GtkWidget *image_busqueda;
   GtkWidget *button_anterior;
   GtkWidget *button_siguiente;
   GtkWidget *label_host;
   GtkWidget *label_imagen;
   char *nombre_servidor;
   gboolean ver_imagenes;
   char cadena[TAM_NOMBRE_IMAGEN];
   char path_imagen[TAM_NOMBRE_IMAGEN];
   char *nombre_imagen;
   char *str_imagen;  

   caja_texto = lookup_widget(GTK_WIDGET(button),"entry_Host");
   check_ver_imagenes = GTK_WIDGET(lookup_widget(GTK_WIDGET(button),"checkbutton_Mostrar_Resultados"));
   establecer_widget_referencia(button);
   nombre_servidor = (char *)gtk_entry_get_text(GTK_ENTRY(caja_texto));
   if (strcmp(nombre_servidor,"") == 0) {
      // Si la caja de texto esta vacia no se continua la ejecucion
      imprimir_informacion_estado("¡Es necesario introducir un nombre para el servidor!",MODO_GRAFICO); 
      return;
   }

   imprimir_informacion_estado("Ejecutando el cazador de imágenes...",MODO_GRAFICO);
   gtk_widget_set_sensitive(GTK_WIDGET(button),FALSE);
   gtk_widget_set_sensitive(GTK_WIDGET(check_ver_imagenes),FALSE);
   gtk_widget_set_sensitive(GTK_WIDGET(caja_texto),FALSE);


   if (lista_imagenes != NULL) {
      vaciar_cola(lista_imagenes);
   }
   cazador_imagenes(nombre_servidor,GTK_WIDGET(button));
   imprimir_informacion_estado("Caza de imágenes finalizada",MODO_GRAFICO);

   ver_imagenes = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check_ver_imagenes));
   if (ver_imagenes == TRUE) {
      // Si el checkbutton esta activado se muestran las imagenes encontradas
      if (!cola_vacia(lista_imagenes)) {
         window_Resultados = create_window_Resultados();
         gtk_widget_show (window_Resultados);

         label_host = lookup_widget(GTK_WIDGET(window_Resultados),"label_Nombre_Host");
         sprintf(cadena,"Dirección analizada: %s",nombre_servidor);
         gtk_label_set_text(GTK_LABEL(label_host),cadena);

         reiniciar_PDI(lista_imagenes);
         nombre_imagen = (char *)obtener_elemento_PDI(lista_imagenes);

         label_imagen = lookup_widget(GTK_WIDGET(window_Resultados),"label_Nombre_Imagen");
         str_imagen = strrchr(&nombre_imagen[0],'/');
         str_imagen++;
         sprintf(cadena,"Imagen cazada: %s",str_imagen);
         gtk_label_set_text(GTK_LABEL(label_imagen),cadena);

         obtener_ruta_imagen(path_imagen,nombre_directorio,nombre_imagen);
         image_busqueda = lookup_widget(GTK_WIDGET(window_Resultados),"image_Imagen_Cazada");
         gtk_image_set_from_file(GTK_IMAGE(image_busqueda),path_imagen); 

         button_anterior = lookup_widget(GTK_WIDGET(window_Resultados),"button_Anterior");
         gtk_widget_set_sensitive(GTK_WIDGET(button_anterior),FALSE);
         int numero_imagen = 1;
         if (lista_imagenes -> total == 1) {
            button_siguiente = lookup_widget(GTK_WIDGET(button),"button_Siguiente");
            gtk_widget_set_sensitive(GTK_WIDGET(button_siguiente),FALSE);
         }
      }
   }
   gtk_widget_set_sensitive(GTK_WIDGET(button),TRUE);
   gtk_widget_set_sensitive(GTK_WIDGET(check_ver_imagenes),TRUE);
   gtk_widget_set_sensitive(GTK_WIDGET(caja_texto),TRUE);
}


void on_button_Anterior_clicked (GtkButton *button, gpointer user_data)
{
   GtkWidget *button_siguiente;
   char cadena[TAM_NOMBRE_IMAGEN];
   char *nombre_imagen;
   char path_imagen[TAM_NOMBRE_IMAGEN];
   GtkWidget *image_busqueda;
   GtkWidget *label_imagen;
   int indice_actual = 1;

   if ((numero_imagen > 1) && (numero_imagen <= lista_imagenes -> total)) {
      numero_imagen--;
      reiniciar_PDI(lista_imagenes);
      nombre_imagen = (char *)obtener_elemento_PDI(lista_imagenes);
      while((indice_actual < numero_imagen) && (nombre_imagen != NULL)) {
         avanzar_PDI(lista_imagenes);
         nombre_imagen = (char *)obtener_elemento_PDI(lista_imagenes);
         indice_actual++;
      }
      obtener_ruta_imagen(path_imagen,nombre_directorio,nombre_imagen);
      image_busqueda = lookup_widget(GTK_WIDGET(button),"image_Imagen_Cazada");
      label_imagen = lookup_widget(GTK_WIDGET(button),"label_Nombre_Imagen");
      sprintf(cadena,"Imagen %s",path_imagen);
      gtk_label_set_text(GTK_LABEL(label_imagen),cadena);
      gtk_image_set_from_file(GTK_IMAGE(image_busqueda),path_imagen);
      button_siguiente = lookup_widget(GTK_WIDGET(button),"button_Siguiente");
      gtk_widget_set_sensitive(GTK_WIDGET(button_siguiente),TRUE);
      if (numero_imagen == 1) {
         gtk_widget_set_sensitive(GTK_WIDGET(button),FALSE);
      }
   }
   else {
      gtk_widget_set_sensitive(GTK_WIDGET(button),FALSE);
   }
}


void on_button_Siguiente_clicked (GtkButton *button, gpointer user_data)
{
   char *nombre_imagen;
   char path_imagen[TAM_NOMBRE_IMAGEN];
   GtkWidget *image_busqueda;
   GtkWidget *label_imagen;
   GtkWidget *button_anterior;
   char cadena[TAM_NOMBRE_IMAGEN];

   nombre_imagen = (char *)obtener_elemento_PDI(lista_imagenes);
   if (nombre_imagen != NULL) {
      avanzar_PDI(lista_imagenes);
      nombre_imagen = (char *)obtener_elemento_PDI(lista_imagenes);
      if (nombre_imagen != NULL) {
         numero_imagen++;
         obtener_ruta_imagen(path_imagen,nombre_directorio,nombre_imagen);
         image_busqueda = lookup_widget(GTK_WIDGET(button),"image_Imagen_Cazada");
         label_imagen = lookup_widget(GTK_WIDGET(button),"label_Nombre_Imagen");
         sprintf(cadena,"Imagen %s",path_imagen);
         gtk_label_set_text(GTK_LABEL(label_imagen),cadena);
         gtk_image_set_from_file(GTK_IMAGE(image_busqueda),path_imagen);
         button_anterior = lookup_widget(GTK_WIDGET(button),"button_Anterior");
         gtk_widget_set_sensitive(GTK_WIDGET(button_anterior),TRUE);
         if (numero_imagen == lista_imagenes -> total) {
            gtk_widget_set_sensitive(GTK_WIDGET(button),FALSE);
         }
      }
      else {
         gtk_widget_set_sensitive(GTK_WIDGET(button),FALSE);
      }
   }
   else {
      gtk_widget_set_sensitive(GTK_WIDGET(button),FALSE);
   }
}


void on_window_Principal_destroy (GtkObject *object, gpointer user_data)
{
   gtk_main_quit();
}


void on_window_Resultados_destroy (GtkObject *ventana, gpointer user_data)
{
   gtk_widget_destroy(GTK_WIDGET(ventana));
}


void *obtener_ruta_imagen (char *path_imagen, char *directorio, char *imagen) 
{
   char *nombre_imagen;
   char *dir;
   int comienzo_imagen;
   int i;

   dir = directorio;
   if (strncmp(dir,"www.",4) == 0) {
      dir += 4;
   }
   sprintf(path_imagen,"images/%s",dir);
   strcat(path_imagen,"/");
   nombre_imagen = strrchr(&imagen[0],'/');
   if (nombre_imagen != NULL) {
      nombre_imagen++;
      strcat(path_imagen,nombre_imagen);
   }
   else {
      strcat(path_imagen,imagen);
   }
}


void cazador_imagenes (char* string_servidor, GtkWidget *objeto)
{
   Cola *cola;
   int sock;
   char texto_html[TAM_FICHERO_HTML];
   char sentencia[TAM_SENTENCIA_HTTP];
   static char directorio[TAM_NOMBRE_DIRECTORIO];
   char mensaje[100];
   int home_page;
   char *imagen, *copia;   
   char nombre_servidor[TAM_NOMBRE_IMAGEN];
   char html_enlace[TAM_NOMBRE_IMAGEN];
   
   // Pagina tipo http://www.servidor.com*
   if (comprobar_imagen_enlazada(string_servidor, nombre_servidor, html_enlace)) {
      // Conexion TCP al puerto 80 del servidor
      sock = conexion_servidor(nombre_servidor,MODO_GRAFICO);
      if (sock == -1) {
         return;
      }
      
      // Si la direccion es http://www.servidor.com <- sin barra ni pagina
      if (strcmp(html_enlace, "")==0) {
         strcpy(html_enlace, "/");
      }
      construir_peticion_http(PETICION_HOME_PAGE,sentencia,nombre_servidor,html_enlace);
      
   } else { 
      // Indicado servidor como parametro www.servidor.com
      strcpy(nombre_servidor,string_servidor);
      
      // Conexion TCP al puerto 80 del servidor
      sock = conexion_servidor(nombre_servidor,MODO_GRAFICO);
      if (sock == -1) {
         return;
      }
      
      construir_peticion_http(PETICION_HOME_PAGE,sentencia,nombre_servidor,"/");
   }
   
   home_page = obtener_home_page(sock,sentencia,texto_html,nombre_servidor,MODO_GRAFICO);
   close(sock);
      
   if (!home_page) {
      return;
   }
   
   // Extraccion de las imagenes referenciadas en la pagina de inicio del servidor
   // Los paths de las imagenes extaidas estaran almacenados en la cola recibida

   cola = buscador_imagenes(texto_html);

   lista_imagenes = crear_cola();   
   if (!cola_vacia(cola)) {
      
      // Comprobacion de la existencia del directorio de almacenamiento y del
      // subdirectorio que almacenara las imagenes del servidor actual.
      
      strcpy(directorio,"images");
      comprobar_directorio(directorio,"",DIRECTORIO_RAIZ);
      comprobar_directorio(directorio,nombre_servidor,SUBDIRECTORIO);
      nombre_directorio = nombre_servidor;
      
      // Obtencion de todas las imagenes de la pagina de inicio mediante solicitud HTTP.
      // Ubicacion de las imagenes recibidas en el directorio especificado.
      
      solicitar_imagenes(nombre_servidor,cola,directorio,MODO_GRAFICO);
      reiniciar_PDI(cola);
      imagen = (char *)obtener_elemento_PDI(cola);
      while(imagen != NULL) {
         copia = (char *)malloc(strlen(imagen) * sizeof(char));
         strcpy(copia,imagen);
         encolar(lista_imagenes,copia);
         avanzar_PDI(cola);
         imagen = (char *)obtener_elemento_PDI(cola);
      }
   }
   else {
      sprintf(mensaje,"\nNo se han encontrado imagenes en la pagina de inicio de %s.\n\n",nombre_servidor);
      imprimir_informacion_estado(mensaje,MODO_GRAFICO);
   }
}

